﻿using System;
using System.Linq;
using System.IO;
using System.IO.IsolatedStorage;
using System.Collections.Generic;
using Microsoft.LightSwitch;
using Microsoft.LightSwitch.Framework.Client;
using Microsoft.LightSwitch.Presentation;
using Microsoft.LightSwitch.Presentation.Extensions;
using System.Windows.Printing;
using System.Windows;

namespace LightSwitchApplication
{
    public partial class CustomersListDetail
    {
        partial void PrintInvoice_Execute()
        {
            // Only run if there is a Customer selected
            if (this.Customers.SelectedItem != null)
            {
                Microsoft.LightSwitch.Threading.Dispatchers.Main.BeginInvoke(() =>
                {
                    System.Text.StringBuilder codeToRun = new System.Text.StringBuilder();
                    codeToRun.Append("window.open(");
                    codeToRun.Append("\"");
                    codeToRun.Append(string.Format("{0}", String.Format(@"{0}/Report.aspx?CustomerID={1}",
                        GetBaseAddress(), this.Customers.SelectedItem.Id.ToString())));
                    codeToRun.Append("\",");
                    codeToRun.Append("\"");
                    codeToRun.Append("\",");
                    codeToRun.Append("\"");
                    codeToRun.Append("width=680,height=640");
                    codeToRun.Append(",scrollbars=yes,menubar=no,toolbar=no,resizable=yes");
                    codeToRun.Append("\");");

                    try
                    {
                        System.Windows.Browser.HtmlPage.Window.Eval(codeToRun.ToString());
                    }

                    catch (Exception ex)
                    {
                        MessageBox.Show(ex.Message,
                            "Error", MessageBoxButton.OK);
                    }
                });
            }
        }

        #region GetBaseAddress
        private static Uri GetBaseAddress()
        {
            // Get the web address of the .xap that launched this application
            string strBaseWebAddress = System.Windows.Browser.HtmlPage.Document.DocumentUri.AbsoluteUri;

            // Find the position of the ClientBin directory        
            int PositionOfClientBin =
                System.Windows.Browser.HtmlPage.Document.DocumentUri.AbsoluteUri.ToLower().IndexOf(@"/default");

            // Strip off everything after the ClientBin directory         
            strBaseWebAddress = Microsoft.VisualBasic.Strings.Left(strBaseWebAddress, PositionOfClientBin);

            // Create a URI
            Uri UriWebService = new Uri(String.Format(@"{0}", strBaseWebAddress));

            // Return the base address          
            return UriWebService;
        }
        #endregion
    }
}
